#!/usr/bin/python
from augeas import Augeas # python-augeas package

a = Augeas()

# working with kdump.conf
# needs kdump.aug
KDUMP_PATH = "/files/etc/kdump.conf/"

###
# simple values
print "Simple entries. In the form key-value."
val =  a.get(KDUMP_PATH + "path")
print val # value or None

val =  a.get(KDUMP_PATH + "disk_timeout")
print val # value or None

val =  a.get(KDUMP_PATH + "core_collector")
print val # value or None
print "---"
###

###
# subtree
print "Extra bins and extra modules."\
      " In the subtrees 'extra_bins' and 'extra_modules."\
      " Keys are numbers, values are names of extra bins/modules."
val =  a.match(KDUMP_PATH + "extra_bins/*")
print val # list or None
# list contains full path name
for key in val:
  subval = a.get(key) # key is full path name
  print subval # value

val =  a.match(KDUMP_PATH + "extra_modules/*")
print val # list or None
# list contains full path name
for key in val:
  subval = a.get(key) # key is full path name
  print subval # value
print "---"
###

###
# another subtree
print "Module options. Every module has own subtree."\
      "Every subtree has a tree and key is a name of module option."\
      "Option can have some `name=value' form, so the value is value."
val =  a.match(KDUMP_PATH + "options/*")
print val # list or None
# list contains full path name
for key in val:
  value = a.get(key)
  print "key: ", key, "value: ", value # names of modules, no values
  mod_options = a.match(key+"/*")
  print mod_options # list of module options
  for subkey in mod_options:
    mod_option_value = a.get(subkey)
    print "key: ", subkey, "value: ", mod_option_value # key is module option, value is everything after `=' for this module option
print "---"
###

print "DONE"
